<?php
/**
 * Plugin Name: SmilePay_ATM 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay ATM 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.4.5
 */
add_action('plugins_loaded', 'SmilePayatm_gateway_init', 0);
function SmilePayatm_gateway_init() {


   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }
    class WC_SmilePayatm extends WC_Payment_Gateway {
        public $title;
        public $description;
        public $dcvc;
        public $Rvg2c;
        public $Deadline_date;
        public $Order_OKmain;
        public $reurl;
        public $Verify_key;
        public $Mid_smilepay;

        public function __construct() {
            $this->id = 'SmilePayatm';
            $this->icon = apply_filters('woocommerce_SmilePayatm_icon', plugins_url('log/atm.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePayatm', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
			$this->Deadline_date = $this->settings['Deadline_date'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
			$this->reurl = $this->settings['reurl'];
			$this->Verify_key = $this->settings['Verify_key'];
			$this->Mid_smilepay = $this->settings['Mid_smilepay'];
            $this->Rvg2c =  $this->settings['Rvg2c'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePayatm_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_SmilePayatm', array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
			$urll=get_option('siteurl')."/?respond";
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2ba("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2ba('SmilePay b/ATM'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2ba('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2ba('SmilePay b/ATM úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2ba('Iڤ覡'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2ba('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2ba("SmilePay b/ATM úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2ba('ӮaN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Rvg2c' => array(
                    'title' => __(u2ba('ӮaѼƽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('жJzSmilePayӮaѼƽX'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2ba('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Mid_smilepay' => array(
                    'title' => __(u2ba('ӮaҰѼ'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('жJzSmilePaҽXAҽXӮaxu򥻸ƺ޲zvAнƻsöKJWApҽЫOdť'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Deadline_date' => array(
                    'title' => __(u2ba('úںI'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('úںIAw]ȵLAжJ1~720Aoj720'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'Order_OKmain' => array(
                    'title' => __(u2ba('U榨\ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2ba('U榨\ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'reurl' => array(
                    'title' => __(u2ba('^em'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2ba('^emAбNUCrƻsWؤ(p^eЯdť)</br><font color=red ue size=+1>'.$urll.'</font>', 'woocommerce')),
                    'default' => __('', 'woocommerce')
                )
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePayatm_args($order) {
            global $woocommerce;

            $paymethod = 'atm';
            $order_id = $order->id;
			//*
			$post_status = $order->post_status;
            
			$SmilePayatm_args = array(
                "dcvc" => $this->dcvc,
                "payment_type" => $paymethod,
                "od_sob" => $order_id,
				//*
				"post_status" => $post_status,
                'reurl' => $this->reurl,
                'Rvg2c' => $this->Rvg2c,
                'Verify_key' => $this->Verify_key,
                'Mid_smilepay' => $this->Mid_smilepay,
				'Deadline_date' => $this->Deadline_date,
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_total()),
            );
            $SmilePayatm_args = apply_filters('woocommerce_SmilePayatm_args', $SmilePayatm_args);
            return $SmilePayatm_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P  atm
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
			$order = new WC_Order($order_id);
			
			
			
			$SmilePayatm_args = $this->get_SmilePayatm_args($order);
			
			//P_O_	
			$thepostid = $SmilePayatm_args['od_sob'];
			
			$order_status=$SmilePayatm_args['post_status'];

		if($order_status=='wc-pending')
		{
            //--ystart
			$shipping_method= $order->get_shipping_method();
           
			$getc2cu="N";
			if($_REQUEST['storeid']=='')
			{
				//if($shipping_method==u2ba("tRt7-11¨f"))
                include_once("smilepayc2cup.php");
                $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
                //ˬdyO_ϥί¨f
				if( $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
                {
					$URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                  
					$mappurl="https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&url=".urlencode($URL);
					header("Location: $mappurl"); 
					exit();	
				}
			}
			else
			{
				$c2c_storeaddress=$_REQUEST['storeaddress'];
				$c2c_storename=$_REQUEST['storename'];
				$c2c_storeid=$_REQUEST['storeid'];
				$getc2cu="Y";			
			}
			//--yend

			if(is_numeric($SmilePayatm_args['Deadline_date'])&&(int)$SmilePayatm_args['Deadline_date']<720)
			{
				$Deadline_date_value=$SmilePayatm_args['Deadline_date'];
				$Deadline_date = date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$Deadline_date_value,date("Y")));			
			}
			else
			{$Deadline_date_value="";}
			
            $pur_name = $order->billing_last_name . $order->billing_first_name;
          	//
			if($SmilePayatm_args['reurl']!=''){$Vk=$SmilePayatm_args['reurl']."=".$order->order_key;}else{$Vk='';}
		  	$smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';
			$post_str = 'Dcvc=' . $SmilePayatm_args['dcvc'] .
					'&Rvg2c=' . $SmilePayatm_args['Rvg2c'] .
					'&Pur_name=' .$pur_name.
					'&Tel_number=' .$order->billing_phone.
					'&Address=' .$order->billing_address_1.
					'&Email=' .$order->billing_email.
					'&Data_id=' . $SmilePayatm_args['od_sob'].
					'&od_sob=' . $SmilePayatm_args['od_sob'].
					'&Amount=' . $SmilePayatm_args['amt'].
					'&Deadline_date=' . $Deadline_date.
					'&Roturl_status=' . 'woook'.
					'&Verify_key=' . $SmilePayatm_args['Verify_key'].
					'&Remark=woocommerce';
			$post_strall=$post_str.'&Pay_zg=2'.'&Roturl=' . $Vk;
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_strall);
			$string = curl_exec($ch);
			curl_close($ch);
			
			/*
			update_status=>has_status
			
			
			*/
			//gJƵ
			$xml = simplexml_load_string($string);
			$Status = $xml->Status;
			if(strpos($string,"<SmilePay>")&&$Status=="1")
			{
                 $title = b2ua($this->title);
				//gJqúO-O
				if($xml->PayEndDate==" 23:59:59"){$payenddata="LúO";} else{$payenddata=$xml->PayEndDate;}
				$ordertext="úO覡G<font color=red>$title</font><br>ȦNG<font color=red>".$xml->AtmBankNo."</font><br>bG<font color=red>".$xml->AtmNo."</font><br>úOG<font color=red>".$payenddata."</font></br>pWLúOФúO</br>";
				$order->add_order_note(u2ba($ordertext),"1");
				$ordertext="ФŧRTAtRtSmilePaylܽXG".$xml->SmilePayNO;
				$order->add_order_note(u2ba($ordertext),"0");
				//קq檬A	
				$order->update_status( 'on-hold' );	
				//ܤe
               

				echo u2ba("<font color='red' size='3'>`NGqwߡA|IڡAШúڸƺɳtI</font>");
				$showtext= "<br><br><h1>úOT</h1>úO覡G<font color='red' size='3'>$title</font></td></tr>";
				$showtext=$showtext."<br>ȦNG<font color='red' size='3'>".$xml->AtmBankNo."</font>";
				$showtext=$showtext."<br>bG<font color='red' size='3'>".$xml->AtmNo."</font>";
				$showtext=$showtext."<br>úOG<font color='red' size='3'>".$payenddata."</font>";
				echo u2ba($showtext);
				echo u2ba("<br><font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
				echo "<br><br>".$SmilePayatm_args['Order_OKmain'];
				//--ystart
				if($getc2cu=="Y")
				{
					include "smilepay_function_c2c.php";
					$c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;					
					$scvurls=repeatc2c($c2c_store,$post_str,$SmilePayatm_args['dcvc'],$SmilePayatm_args['Verify_key']);
					$order->add_order_note(u2ba($scvurls),"0");
					$scvurls_1="7-11fG<font color=red>".b2ua($c2c_storename.$c2c_storeid)."</font><br>";
                    $scvurls_1 .= "a}G<font color=red>".b2ua($c2c_storeaddress)."</font><br>";
                    $scvurls_1 .= "fHmWG<font color=red>".b2ua($pur_name)."</font><br>";
                    $scvurls_1 .= "fHqܡG<font color=red>".b2ua($order->billing_phone)."</font><br>";

					$order->add_order_note(u2ba($scvurls_1),"1");
					echo u2ba('<h1>fT</h1>' . $scvurls_1);
				}
				//--yend
				
			}
			else
			{
				if($Status!="")
				{	$ordererror="</br>~NXG".$xml->Status."</br>e]G".$xml->Desc."</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				else
				{	$ordererror="</br>e]Gsu`</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				$order->add_order_note(u2ba($ordererror),"1");
				$order->update_status( 'cancelled' );				
			}
		}
		else
		{
			echo u2ba("<font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
		}			


}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
			$order = new WC_Order( $order_id );
			//--ystart
			$shipping_method= $order->get_shipping_method();

            include_once('smilepayc2cp.php');
            include_once('smilepayc2cup.php');
            $smilepayc2cp_obj=new WC_Smilepayc2cp_Shipping_Method();
            $smilepayc2cup_obj=new WC_Smilepayc2cu_Shipping_Method();
            if($smilepayc2cup_obj->isSelectedSmilepayC2Cup($order_id))
			//if($shipping_method==u2ba("tRt7-11¨f"))
			{
				$username=$order->billing_first_name.$order->billing_last_name;
				if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10||mb_strlen( $username, "utf-8")>5){
          wc_add_notice( __(u2ba("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrCЦAT{C<br>"), 'woothemes') . $error_message, 'error' );
          return;
					exit;
				}
			}
            if($smilepayc2cp_obj->isSelectedSmilepayC2Cp($order_id))
			//if($shipping_method==u2ba("tRt7-11fI"))
			{
          wc_add_notice( __(u2ba("<br><font color='red'>te覡ܿ~Aiܦte覡</font><br>"), 'woothemes') . $error_message, 'error' );
          return;
          exit;
			}
			//--yend
			$order->reduce_order_stock();
			WC()->cart->empty_cart();
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */

    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePayatm_gateway($methods) {
        $methods[] = 'WC_SmilePayatm';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePayatm_gateway');
}
function u2ba($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ua($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
?>